/************************************************************************************\
 * -> Misk functionality on assembler language                                      *
 *                                                                                  *
 * Copyright(c) 2006 Dan Kruchinin (aka asgard)                                     *
 *                                                                                  *
 *                                                                                  *
 * This program is free software; you can redistribute it and/or                    *
 * modify it under the terms of the GNU General Public License                      *
 * as published by the Free Software Foundation; either version 2                   *
 * of the License, or (at your option) any later version.                           *
 *                                                                                  *
 * This program is distributed in the hope that it will be useful,                  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 * GNU General Public License for more details.                                     * 
 *                                                                                  *
 * You should have received a copy of the GNU General Public License                *
 * along with this program; if not, write to the Free Software                      *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
\************************************************************************************/
	
.text

#include <boot/boot.h>

.code32
.align 4
	
.globl _get_cpu_type
.globl _mb_fill_structures

/* _get_cpu_id(int* id, char* vendor) */
_get_cpu_type:
	pushl %ebp
	movl %esp, %ebp

	movl $7, 4(%ebp)
	
	pushfl
	popl %eax /* copy EFLAGS to eax */
	movl %eax, %ecx /* save old EFLAGS to ebx */
	movl $0x240000, %eax /* set ID and AC flags */
	pushl %eax
	popfl /* load new EFLAGS */
	pushfl
	popl %eax
	xorl %ecx, %eax
	pushl %ecx
	popfl
	testl $0x040000, %eax /* if our proccessor is 386 */
	jz exsep_386
	testl $0x200000, %eax /* on some 486 proccessors ID bit can't be set */
	jz exsep_486

	movl $0, %eax
	cpuid

	/* save cpuid in first argument and vendor in the second */
	//movl %eax,  %ebp
	//addl $0x20, %ebp

	movl %ebp, %esp
	popl %ebp
	ret

exsep_386:
	/* FIXME: Can I know, should we support intel 386 or not? */
	pushl $0
	jmp cpu_unsupported

exsep_486:
	/* FIXME: What we should to do with 486 family, that don't support cpuid */
	pushl $1
	jmp cpu_unsupported

cpu_unsupported:
	popl %eax /* 0 eq 386, 1 eq 486 */
	/* FIXME: change this stupid line... in future... */
	jmp cpu_unsupported

_mb_fill_structures:
	pushl %ebp
	movl %esp, %ebp

	movl %ebx, 4(%ebp)
	
	movl %ebp, %esp
	popl %ebp
	ret
