/************************************************************************************\
 * Copyright(c) 2006 Dan Kruchinin (aka asgard)                                     *
 *                                                                                  *
 *                                                                                  *
 * This program is free software; you can redistribute it and/or                    *
 * modify it under the terms of the GNU General Public License                      *
 * as published by the Free Software Foundation; either version 2                   *
 * of the License, or (at your option) any later version.                           *
 *                                                                                  *
 * This program is distributed in the hope that it will be useful,                  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 * GNU General Public License for more details.                                     * 
 *                                                                                  *
 * You should have received a copy of the GNU General Public License                *
 * along with this program; if not, write to the Free Software                      *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
\************************************************************************************/

OUTPUT_FORMAT("elf32-i386")
ENTRY(_start)

VIRT_ADDR = 0xC0000000;
PHYS_ADDR = 0x100000;   

SECTIONS
{
   .text VIRT_ADDR : AT(PHYS_ADDR)
   {
      text_start = .;
      *(.text)
      . = ALIGN(0x1000);
   }

   .data : AT(PHYS_ADDR + data_start - text_start)
   {
      data_start = .;
      *(.data)
      *(.rodata)
      . = ALIGN(0x1000);
   }

   .bss : AT(PHYS_ADDR + bss_start - text_start)
   {
      bss_start = .;
      *(.bss)
      *(COMMON)
      . = ALIGN(0x1000);
   }

   _end = .;
}
