/************************************************************************************\
 * Copyright(c) 2006 Dan Kruchinin (aka asgard)                                     *
 *                                                                                  *
 *                                                                                  *
 * This program is free software; you can redistribute it and/or                    *
 * modify it under the terms of the GNU General Public License                      *
 * as published by the Free Software Foundation; either version 2                   *
 * of the License, or (at your option) any later version.                           *
 *                                                                                  *
 * This program is distributed in the hope that it will be useful,                  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 * GNU General Public License for more details.                                     * 
 *                                                                                  *
 * You should have received a copy of the GNU General Public License                *
 * along with this program; if not, write to the Free Software                      *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
\************************************************************************************/


#include <config.h>
#include <klib/kio.h>
#include <klib/types.h>
#include <boot/boot.h>
#include <arch/mm.h>
#include <arch/setup.h>
#include <arch/string.h>

mb_info* _mi;


void setup_arch()
{
  udlong t = 0;
  udlong i;
  int a = 5;
  mmap* mmp;

  if(!(_mi->flags & 0x40))
	kfprintf(KOS_ERROR, "mmap is invalid\n");
  
  t = 0;

  for(mmp = (mmap*)_mi->mmap_addr; (uint32_t)mmp < _mi->mmap_addr + _mi->mmap_length; mmp = (mmap*)((ulong)mmp + mmp->size + sizeof(mmp->size))) {
	kprintf("SIZE = %d bytes [%d megabutes]\n", mmp->size, mmp->size / 1024 / 1024);
	i = mmp->base_addr_low | (mmp->base_addr_high << 32);
	kprintf("ADDRESS = %#llx\n", i);
	i = mmp->length_low | (mmp->length_high << 32);
	t += i;
	kprintf("LENGTH = %lld bytes [%lld megabytes]\n", i, i / 1024 / 1024);
	kprintf("TYPE = %s\n\n", (mmp->type == 1) ? "RAM" : "RESERVED");
  }

  kprintf("\n\nSUMMARY AMOUNT OF RAM = %lld [%lld mb]", t, t / 1024 / 1024);
}
