/*
 * Errors describing for the internal microkernel
 * purposes.
 *
 * Written by Alfeiks Kaanoken <akaanoken@gmail.com>
 *
 * (c) 2004, 2006
 *
 * This software is free software; you can redistribute it and/or                
 * modify it under the terms of the GNU Lesser General Public                   
 * License as published by the Free Software Foundation; either                 
 * version 2 of the License, or (at your option) any later version.             
 *                                                                              
 * This software is distributed in the hope that it will be useful,              
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            
 * Lesser General Public License for more details.                              
 *                                                                              
 * You should have received a copy of the GNU Lesser General Public             
 * License along with this library; if not, write to the                        
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,                 
 * Boston, MA 02111-1307, USA. 
 *
 *
 */

/*general things*/
#define SUCCESS                           0
#define FAILED                            -127
#define FAIL  FAILED

/*internal memory operations errors*/

#define IMM_NENOUGH                       1
#define IMM_INVALPTR                      2
#define IMM_EACCESS                       3
#define IMM_INVAOP                        4
#define IMM_OVERLOAD                      5
#define IMM_FAILED                        6

/*servers errors*/

/*registration*/
#define NS_REGFAIL                        7
#define NS_REGERR                         8
#define NS_REGEACCESS                     9
#define NS_REGINVALID                     10
#define NS_SERVERBUSY                     11
#define NS_SERVERSLOTFULL                 102
#define NS_NOSUCHSERVER                   103
#define NS_SERVEREXITS                    104
#define NS_PATHSSLOTFULL                  105
#define NS_NOSUCHROUTE                    106

/*routing*/
#define NS_ROUTEINVALID                   11
#define NS_ROUTEFAIL                      12
#define NS_ROUTETIMEOUT                   13
#define NS_ROUTENOTFOUND                  14

/*protocol errors*/
#define JP_ERRCHUNK                       15
#define JP_TIMEOUT                        16
#define JP_INVALIDHDR                     17
#define JP_UNKNOWNFRAME                   18
#define JP_INVALIDPARAM                   19
#define JP_INVALIDCHKSUM                  20
#define JP_EACCESS                        21
#define JP_NOTNODE                        22
#define JP_NOTCPU                         23
#define JP_INVPTR                         24
#define JP_NOTSAME                        25
#define JP_ERRACCESS                      26
#define JP_NOTAFRAME                      27
#define JP_ERRPARSE                       28
#define JP_NOTROUTE                       29
#define JP_NONJP                          30
#define JP_UNAVIALABLE                    31

