/*
 * Permission control.
 * The part of the Jari microkernel.
 *
 * Written by Alfeiks Kaanoken <akaanoken@gmail.com>
 * (c) 2001
 *
 * This software is free software; you can redistribute it and/or                
 * modify it under the terms of the GNU Lesser General Public                   
 * License as published by the Free Software Foundation; either                 
 * version 2 of the License, or (at your option) any later version.             
 *                                                                              
 * This software is distributed in the hope that it will be useful,              
 * but WITHOUT ANY WARRANTY; without even the implied warranty of               
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU            
 * Lesser General Public License for more details.                              
 *                                                                              
 * You should have received a copy of the GNU Lesser General Public             
 * License along with this library; if not, write to the                        
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,                 
 * Boston, MA 02111-1307, USA. 
 *
 */

#ifndef __PERM_H__
#define __PERM_H__

#define PERM_RW  1
#define PERM_RO  2
#define PERM_NA  3

typedef struct __perm_t {
  int user_id; /*access control information*/
  int group_id;
  int node_id;
  int u_asc;
  int g_asc;
  int o_asc;
  int n_asc;
} perm_t;

int check_user_perm(perm_t src, perm_t orig);
int check_group_perm(perm_t src, perm_t orig);
int check_node_perm(perm_t src, perm_t orig);

perm_t get_user_permission(void *task);
perm_t get_node_permission(void *node);

#endif
