/*
 * Virtual file system implementation.
 * Type macroses.
 * The part of the Jari microkernel.
 *
 * Written by Alfeiks Kaanoken <akaanoken@gmail.com>
 * (c) 2006
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the                                                                                                
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * under GNU Lesser General Public License
 *
 */

#ifndef __VFS__TYPES_H__
#define __VFS__TYPES_H__

#include <perm.h>

#define VFS_REGULAR    1
#define VFS_POINT      2
#define VFS_MEMORY     3
#define VFS_DEVICE     4
#define VFS_SERVER     5
#define VFS_PIPE       6
#define VFS_INTERFACE  7
#define VFS_SOCKET     8
#define VFS_BUFFER     9
#define VFS_CPU        10
#define VFS_HOST       11
#define VFS_NODE       12
#define VFS_FS         13
#define VFS_VIDEO      14
#define VFS_CUSTOM     15
#define VFS_LINK       16

#define PNT_SEP        '/'

/*varios types for vfs*/

typedef struct __stat_t {
  int kern_load; /*load avergage*/
  int serv_load;
  int user_load;
  unsigned long rx; /*traffic avergage*/
  unsigned long tx;
  unsigned long ticks; /*the improvment weight*/
  unsigned long offs; /*size*/
  unsigned long blk_c; /*size in block*/
  unsigned long fnode_c; /*size in fnode*/
  int links; /*number of the links*/
  perm_t perm; /*permissions*/
  time_t last; /*last access time*/
  time_t creat; /*last create/modify time*/
  time_t state; /*last time of the state changing*/
  void *custom; /*reserved for the custom data*/
} stat_t;

#endif
