/************************************************************************************\
 * > ikernel/include/video/kconsole.h                                               *
 * - basic functions and definitions for implementation kernel console              *
 *                                                                                  *
 * Copyright(c) 2006 Dan Kruchinin (aka asgard)                                     *
 *                                                                                  *
 *                                                                                  *
 * This program is free software; you can redistribute it and/or                    *
 * modify it under the terms of the GNU General Public License                      *
 * as published by the Free Software Foundation; either version 2                   *
 * of the License, or (at your option) any later version.                           *
 *                                                                                  *
 * This program is distributed in the hope that it will be useful,                  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 * GNU General Public License for more details.                                     * 
 *                                                                                  *
 * You should have received a copy of the GNU General Public License                *
 * along with this program; if not, write to the Free Software                      *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
\************************************************************************************/

#ifndef __KCONSOLE_H__
#define __KCONSOLE_H__

#include <config.h>
#include <klib/types.h>
#include <video/vga.h>
#include <arch/types.h>

#ifndef KCONS_DEF_BG
#define KCONS_DEF_BG BLACK
#endif /* KCONS_DEF_BG */

#ifndef KCONS_DEF_FG
#define KCONS_DEF_FG WHITE
#endif /* KCONS_DEF_FG */

#ifdef KCONS_COLOR_MODE

#ifndef KCONS_WARN_BG
#define KCONS_WARN_BG BLACK
#endif /* KCONS_WARN_BG */

#ifndef KCONS_WARN_FG
#define KCONS_WARN_FG RED
#endif /* KCONS_WARN_FG */

#ifndef KCONS_WARN_BL
#define KCONS_WARN_BL 1
#endif /* KCONS_WARN_BL */

#ifndef KCONS_ERR_BG
#define KCONS_ERR_BG BLACK
#endif /* KCONS_ERR_BG */

#ifndef KCONS_ERR_FG
#define KCONS_ERR_FG RED
#endif /* KCONS_ERR_BG */

#ifndef KCONS_ERR_BL
#define KCONS_ERR_BL 1
#endif /* KCONS_ERR_BL */

#endif /* KCONS_COLOR_MODE */

typedef struct kconsole {
  void (*enable)();
  void (*greeting)();
  bool (*is_enable)();
  void (*display_string)(const char*);
  void (*display_char)(const char);
  void (*disable)();
  bool __enable;
} kconsole;

extern kconsole kcons;

#endif /* __KCONSOLE_H__ */
