/************************************************************************************\
 * Copyright(c) 2006 Dan Kruchinin (aka asgard)                                     *
 *                                                                                  *
 *                                                                                  *
 * This program is free software; you can redistribute it and/or                    *
 * modify it under the terms of the GNU General Public License                      *
 * as published by the Free Software Foundation; either version 2                   *
 * of the License, or (at your option) any later version.                           *
 *                                                                                  *
 * This program is distributed in the hope that it will be useful,                  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                    *
 * GNU General Public License for more details.                                     * 
 *                                                                                  *
 * You should have received a copy of the GNU General Public License                *
 * along with this program; if not, write to the Free Software                      *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.  *
\************************************************************************************/

#ifndef __PAGE_H__
#define __PAGE_H__

#include <arch/types.h>

#define KDATA 1

#define TBL_SELECTOR(arg) ((arg) << 3)
/* uesr space starts from this address. I.e. 3GB.*/
#define PAGE_OFFSET 0xC0000000

#define GET_REAL_ADDR(addr) ((addr) - PAGE_OFFSET)
#define GET_VIRT_ADDR(addr) ((addr) + PAGE_OFFSET)

#define PAGE_SHIFT 12
#define PAGE_SIZE (1 << 12)

/* early boot page table - maps first 8M */
#define EB_KPDE 0x1000 /* kernel page directory address */
#define EB_KPTE 0x2000 /* kernel page table entry */
#define EB_IPTE 0x3000 /* identify page table entry */

/* CR4 major flags */
#define PGCR4_PSE (1 << 4) /* enable page size - 4M */
#define PGCR4_PAE (1 << 5) /* physical address extention */

/* page directory flags */
#define PGD_PRESENT  (1 << 0)
#define PGD_WRITABLE (1 << 1)
#define PGD_USER     (1 << 2)

#ifndef __ASM__

//typedef ulong pd;

#endif /* __ASM__ */
#endif /* __PAGE_H__ */
